/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the GatewaysList type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &GatewaysList{}

// GatewaysList struct for GatewaysList
type GatewaysList struct {
	Results []Gateway `json:"results"`
	Total int32 `json:"total"`
}

// NewGatewaysList instantiates a new GatewaysList object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewGatewaysList(results []Gateway, total int32) *GatewaysList {
	this := GatewaysList{}
	this.Results = results
	this.Total = total
	return &this
}

// NewGatewaysListWithDefaults instantiates a new GatewaysList object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewGatewaysListWithDefaults() *GatewaysList {
	this := GatewaysList{}
	return &this
}

// GetResults returns the Results field value
func (o *GatewaysList) GetResults() []Gateway {
	if o == nil {
		var ret []Gateway
		return ret
	}

	return o.Results
}

// GetResultsOk returns a tuple with the Results field value
// and a boolean to check if the value has been set.
func (o *GatewaysList) GetResultsOk() ([]Gateway, bool) {
	if o == nil {
		return nil, false
	}
	return o.Results, true
}

// SetResults sets field value
func (o *GatewaysList) SetResults(v []Gateway) {
	o.Results = v
}

// GetTotal returns the Total field value
func (o *GatewaysList) GetTotal() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.Total
}

// GetTotalOk returns a tuple with the Total field value
// and a boolean to check if the value has been set.
func (o *GatewaysList) GetTotalOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Total, true
}

// SetTotal sets field value
func (o *GatewaysList) SetTotal(v int32) {
	o.Total = v
}

func (o GatewaysList) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o GatewaysList) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["results"] = o.Results
	toSerialize["total"] = o.Total
	return toSerialize, nil
}

type NullableGatewaysList struct {
	value *GatewaysList
	isSet bool
}

func (v NullableGatewaysList) Get() *GatewaysList {
	return v.value
}

func (v *NullableGatewaysList) Set(val *GatewaysList) {
	v.value = val
	v.isSet = true
}

func (v NullableGatewaysList) IsSet() bool {
	return v.isSet
}

func (v *NullableGatewaysList) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableGatewaysList(val *GatewaysList) *NullableGatewaysList {
	return &NullableGatewaysList{value: val, isSet: true}
}

func (v NullableGatewaysList) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableGatewaysList) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


